Package org.astrogrid.samp.hub

# Class Hub

java.lang.Object
org.astrogrid.samp.hub.Hub

public class Hub extends Object
Class which manages a hub and its associated profiles. Static methods are provided for starting a hub in the current or an external JVM, and a `main()` method is provided for use from the command line.

Some of the static methods allow you to indicate which hub profiles should be used, others use a default. The default list can be set programmatically by using the `setDefaultProfileClasses(java.lang.Class[], boolean)` method or externally by using the "jsamp.hub.profiles" and "jsamp.hub.profiles.extra" system properties. So, for instance, running an application with `-Djsamp.hub.profiles=web,std` will cause it to run hubs using both the Standard and Web profiles if it does not explicitly choose profiles.

Since:
  31 Jan 2011
Author:
  Mark Taylor, Sylvain Lafrasse

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`EXTRAHUBPROFILES_PROP`
System property name for supplying default profiles ("jsamp.hub.profiles.extra") additional to those in `HUBPROFILES_PROP` which will be supported by the hub but switched off at hub startup time.
`static final String`
`HUBPROFILES_PROP`
System property name for supplying default profiles ("jsamp.hub.profiles") available at hub startup.

## Constructor Summary

Constructors
Constructor
Description
`Hub(HubService service)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`static void`
`checkExternalHubAvailability()`
Attempts to determine whether an external hub can be started using `runExternalHub`.
`static HubProfile[]`
`createDefaultProfiles(boolean extra)`
Returns an array of default Hub Profiles.
`static Class[]`
`getDefaultProfileClasses(boolean extra)`
Returns a copy of the default set of HubProfile classes used when a hub is run and the list of profiles is not set explicitly.
`HubService`
`getHubService()`
Returns the hub service associated with this hub.
`static HubProfileFactory[]`
`getKnownHubProfileFactories()`
Returns a standard list of known HubProfileFactories.
`static Hub[]`
`getRunningHubs()`
Returns an array of all the instances of this class which are currently running.
`HubProfile[]`
`getRunningProfiles()`
Returns the hub profiles currently running on behalf of this hub.
`JFrame`
`getWindow()`
Returns a window for user monitoring and control of this hub, if available.
`static void`
`main(String[] args)`
Main method, which allows configuration of which profiles will run and configuration of those individual profiles.
`static HubProfileFactory[]`
`parseProfileList(String listTxt)`
Parses a string representing a list of hub profiles.
`static void`
`runExternalHub(HubServiceMode hubMode)`
Attempts to run a hub in a new JVM with a default set of profiles.
`static void`
`runExternalHub(HubServiceMode hubMode, Class[] profileClasses, Class[] extraProfileClasses)`
Attempts to start a hub in a new JVM with a given set of profiles.
`static Hub`
`runHub(HubServiceMode hubMode)`
Starts a SAMP hub with a default set of profiles.
`static Hub`
`runHub(HubServiceMode hubMode, HubProfile[] profiles, HubProfile[] extraProfiles)`
Starts a SAMP hub with given sets of profiles.
`static int`
`runMain(String[] args)`
Invoked by main.
`static void`
`setDefaultProfileClasses(Class[] clazzes, boolean extra)`
Sets the default set of HubProfile classes.
`void`
`shutdown()`
Stops this hub and its profiles running.
`void`
`startProfile(HubProfile profile)`
Starts a profile running on behalf of this hub.
`void`
`stopProfile(HubProfile profile)`
Stops a profile running on behalf of this hub, and disconnects all clients registered with it.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### HUBPROFILES_PROP

public static final String HUBPROFILES_PROP
System property name for supplying default profiles ("jsamp.hub.profiles") available at hub startup. The value of this property, if any, will be fed to `parseProfileList(java.lang.String)`.

See Also:
  - Constant Field Values

### EXTRAHUBPROFILES_PROP

public static final String EXTRAHUBPROFILES_PROP
System property name for supplying default profiles ("jsamp.hub.profiles.extra") additional to those in `HUBPROFILES_PROP` which will be supported by the hub but switched off at hub startup time. The value of this property, if any, will be fed to `parseProfileList(java.lang.String)`.

See Also:
  - Constant Field Values

## Constructor Details

### Hub

public Hub(HubService service)
Constructor. Note that this object does not start the service, it must be started explicitly, either before or after this constructor is called.

Parameters:
  `service` - hub service

## Method Details

### shutdown

public void shutdown()
Stops this hub and its profiles running.

### startProfile

public void startProfile(HubProfile profile) throws IOException
Starts a profile running on behalf of this hub.

Parameters:
  `profile` - to start
Throws:
  `IOException`

### stopProfile

public void stopProfile(HubProfile profile)
Stops a profile running on behalf of this hub, and disconnects all clients registered with it.

Parameters:
  `profile` - profile to stop

### getHubService

public HubService getHubService()
Returns the hub service associated with this hub.

Returns:
  hub service

### getRunningProfiles

public HubProfile[] getRunningProfiles()
Returns the hub profiles currently running on behalf of this hub.

Returns:
  profiles that have been started and not yet stopped by this hub

### getWindow

public JFrame getWindow()
Returns a window for user monitoring and control of this hub, if available. The default implementation returns null, but this may be overridden depending on how this hub was instantiated.

Returns:
  hub monitor/control window, or null

### getKnownHubProfileFactories

public static HubProfileFactory[] getKnownHubProfileFactories()
Returns a standard list of known HubProfileFactories. This is used when parsing hub profile lists (`parseProfileList(java.lang.String)` to supply the well-known named profiles.

Returns:
  array of known hub profile factories

### getDefaultProfileClasses

public static Class[] getDefaultProfileClasses(boolean extra)
Returns a copy of the default set of HubProfile classes used when a hub is run and the list of profiles is not set explicitly. Each element should be an implementation of `HubProfile` with a no-arg constructor.

Parameters:
  `extra` - false for starting classes, true for additional ones
Returns:
  array of hub profile classes

### setDefaultProfileClasses

public static void setDefaultProfileClasses(Class[] clazzes, boolean extra)
Sets the default set of HubProfile classes.

Parameters:
  `clazzes` - array to be returned by getDefaultProfileClasses
  `extra` - false for starting classes, true for additional ones

### parseProfileList

public static HubProfileFactory[] parseProfileList(String listTxt)
Parses a string representing a list of hub profiles. The result is an array of HubProfileFactories. The list is comma-separated, and each element may be either the `name` of a HubProfileFactory or the classname of a `HubProfile` implementation with a suitable no-arg constructor.

Parameters:
  `listTxt` - comma-separated list
Returns:
  array of hub profile factories
Throws:
  `IllegalArgumentException` - if unknown

### createDefaultProfiles

public static HubProfile[] createDefaultProfiles(boolean extra)
Returns an array of default Hub Profiles. This is the result of calling the no-arg constructor for each element of the result of `getDefaultProfileClasses(boolean)`.

Parameters:
  `extra` - false for starting profiles, true for additional ones
Returns:
  array of hub profiles to use by default

### runHub

public static Hub runHub(HubServiceMode hubMode, HubProfile[] profiles, HubProfile[] extraProfiles) throws IOException
Starts a SAMP hub with given sets of profiles. The returned hub is running.

The `profiles` argument gives the profiles which will be started initially, and the `extraProfiles` argument lists more that can be started under user control later. If either or both list is given as null, suitable defaults will be used.

If the hub mode corresponds to one of the GUI options, one of two things will happen. An attempt will be made to install an icon in the "system tray"; if this is successful, the attached popup menu will provide options for displaying the hub window and for shutting it down. If no system tray is available, the hub window will be posted directly, and the hub will shut down when this window is closed. System tray functionality is only available when running under Java 1.6 or later, and when using a suitable display manager.

Parameters:
  `hubMode` - hub mode
  `profiles` - SAMP profiles to support on hub startup; if null a default set will be used
  `extraProfiles` - SAMP profiles to offer for later startup under user control; if null a default set will be used
Returns:
  running hub
Throws:
  `IOException`

### runHub

public static Hub runHub(HubServiceMode hubMode) throws IOException
Starts a SAMP hub with a default set of profiles. This convenience method invokes `runHub(hubMode,null,null)`.

Parameters:
  `hubMode` - hub mode
Returns:
  running hub
Throws:
  `IOException`
See Also:
  - `runHub(HubServiceMode,HubProfile[],HubProfile[])`

### runExternalHub

public static void runExternalHub(HubServiceMode hubMode, Class[] profileClasses, Class[] extraProfileClasses) throws IOException
Attempts to start a hub in a new JVM with a given set of profiles. The resulting hub can therefore outlast the lifetime of the current application. Because of the OS interaction required, it's hard to make this bulletproof, and it may fail without an exception, but we do our best.

The classes specified by the `profileClasses` and `extraProfileClasses` arguments must implement `HubProfile` and must have a no-arg constructor. If null is given in either case suitable defaults, taken from the current JVM, are used.

Parameters:
  `hubMode` - hub mode
  `profileClasses` - hub profile classes to start on hub startup
  `extraProfileClasses` - hub profile classes which may be started later under user control
Throws:
  `IOException`
See Also:
  - `checkExternalHubAvailability()`

### runExternalHub

public static void runExternalHub(HubServiceMode hubMode) throws IOException
Attempts to run a hub in a new JVM with a default set of profiles. The default set is taken from that in this JVM. This convenience method invokes `runExternalHub(hubMode,null,null)`.

Parameters:
  `hubMode` - hub mode
Throws:
  `IOException`
See Also:
  - `runExternalHub(HubServiceMode,java.lang.Class[],java.lang.Class[])`

### getRunningHubs

public static Hub[] getRunningHubs()
Returns an array of all the instances of this class which are currently running.

Returns:
  running hubs

### checkExternalHubAvailability

public static void checkExternalHubAvailability() throws IOException
Attempts to determine whether an external hub can be started using `runExternalHub`. If it can be determined that such an attempt would fail, this method will throw an exception with an informative message. This method succeeding is not a guarantee that an external hub can be started successfullly. The behaviour of this method is not expected to change over the lifetime of a given JVM.

Throws:
  `IOException`

### main

public static void main(String[] args)
Main method, which allows configuration of which profiles will run and configuration of those individual profiles. Use the `-h` flag for usage.

### runMain

public static int runMain(String[] args) throws IOException
Invoked by main. In case of a usage error, it returns a non-zero value, but does not call System.exit.

Parameters:
  `args` - command-line argument array
Returns:
  non-zero for error completion
Throws:
  `IOException`